import { BehaviorSubject, Observable } from "rxjs";
declare type Updater<T> = (value: T) => T;
export interface IWritable<T> extends Observable<T> {
    set(value: T): void;
    update(updater: Updater<T>): void;
}
export declare class Writable<T> extends BehaviorSubject<T> implements IWritable<T> {
    constructor(initialValue: T);
    set(value: T): void;
    update(fn: Updater<T>): void;
    lift<R>(operator: any): Writable<R>;
}
export declare function readable<T>(initialState: T): Observable<T>;
export declare function writable<T>(initialState: T): Writable<T>;
declare type Stores = Observable<any> | [Observable<any>, ...Array<Observable<any>>];
export declare function derived<T>(stores: Stores, fn: Function, initial_value?: T): Observable<T>;
export {};
